//+------------------------------------------------------------------+ 
//|                                                 Weekly v1.02.mq4 |
//|                                               copyright 2006 DGC |
//+------------------------------------------------------------------+

#property copyright "Copyright  2006 DGC"

extern double     dLastClose;
extern int        iTradeSpacing  = 50;
extern int        iStopSpacing   = 30;
extern double     Lots           = 0.1;

double            dLongEntry;
double            dShortEntry;
double            dLongStop;
double            dShortStop;
int            slippage       = 3;
bool           bInitialize    = True;
bool           bFirstEntry    = True;
bool           bInLong        = False;
bool           bInShort       = False;
int            iLongTicket;
int            iShortTicket;
string         CurrentBuild   = "v1.02";

int init(){return(0);}
int deinit(){return(0);}

int start()
{
   if (bInitialize == True)
   {
      dLongEntry = dLastClose + iTradeSpacing * Point;
      ObjectCreate ("LONG_ENTRY", OBJ_HLINE, 0, 0, dLongEntry);
      ObjectSet ("LONG_ENTRY", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet ("LONG_ENTRY", OBJPROP_COLOR, Blue);
      dLongStop = dLongEntry - iStopSpacing * Point;
      ObjectCreate ("LONG_STOP", OBJ_HLINE, 0, 0, dLongStop);
      ObjectSet ("LONG_STOP", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet ("LONG_STOP", OBJPROP_COLOR, Gray);
      dShortEntry = dLastClose - iTradeSpacing * Point;
      ObjectCreate ("SHORT_ENTRY", OBJ_HLINE, 0, 0, dShortEntry);
      ObjectSet ("SHORT_ENTRY", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet ("SHORT_ENTRY", OBJPROP_COLOR, Red);
      dShortStop = dShortEntry + iStopSpacing * Point;
      ObjectCreate ("SHORT_STOP", OBJ_HLINE, 0, 0, dShortStop);
      ObjectSet ("SHORT_STOP", OBJPROP_STYLE, STYLE_DOT);
      ObjectSet ("SHORT_STOP", OBJPROP_COLOR, Yellow);
      bInitialize = False;
   }
   else
   {
      if (bInLong == True)
      {
         if (Bid <= dLongStop)
         {
            OrderClose (iLongTicket, Lots, slippage, Blue);
            dLongEntry = Bid + iTradeSpacing * Point;
            ObjectSet ("LONG_ENTRY", OBJPROP_PRICE1, dLongEntry);
            dLongStop = dLongEntry - iStopSpacing * Point;
            ObjectSet ("LONG_STOP", OBJPROP_PRICE1, dLongStop);
            dShortEntry = Bid - iTradeSpacing * Point;
            ObjectSet ("SHORT_ENTRY", OBJPROP_PRICE1, dShortEntry);
            dShortStop = dShortEntry + iStopSpacing * Point;
            ObjectSet ("SHORT_STOP", OBJPROP_PRICE1, dShortStop);
            bInLong = False;
         }
         if (Bid - dLongEntry > iStopSpacing * Point && Bid - dLongStop > iStopSpacing * Point)
         {
            dLongStop = Bid - iStopSpacing * Point;
            ObjectSet ("LONG_STOP", OBJPROP_PRICE1, dLongStop);
         }   
      }   
      else
      {      
         if (Bid >= dLongEntry)
         {
            if (bFirstEntry == True)
            {
               iLongTicket = OrderSend (Symbol(), OP_BUY, Lots, Ask, slippage, 0, 0, NULL, 0, 0, Blue);
               dShortEntry = dLastClose;
               ObjectSet ("SHORT_ENTRY", OBJPROP_PRICE1, dShortEntry);
               dShortStop = dShortEntry + iStopSpacing * Point;
               ObjectSet ("SHORT_STOP", OBJPROP_PRICE1, dShortStop);
               bFirstEntry = False;
               bInLong = True;
            }
            else
            {
               iLongTicket = OrderSend (Symbol(), OP_BUY, Lots, Ask, slippage, 0, 0, NULL, 0, 0, Blue);
               bInLong = True;
            }
         }
      }   

      if (bInShort == True)
      {
         if (Ask >= dShortStop)
         {
            OrderClose (iShortTicket, Lots, slippage, Red);
            dLongEntry = Bid + iTradeSpacing * Point;
            ObjectSet ("LONG_ENTRY", OBJPROP_PRICE1, dLongEntry);
            dLongStop = dLongEntry - iStopSpacing * Point;
            ObjectSet ("LONG_STOP", OBJPROP_PRICE1, dLongStop);
            dShortEntry = Bid - iTradeSpacing * Point;
            ObjectSet ("SHORT_ENTRY", OBJPROP_PRICE1, dShortEntry);
            dShortStop = dShortEntry + iStopSpacing * Point;
            ObjectSet ("SHORT_STOP", OBJPROP_PRICE1, dShortStop);
            bInShort = False;
         }
         if (dShortEntry - Bid > iStopSpacing * Point && dShortStop - Bid > iStopSpacing * Point)
         {
            dShortStop = Bid + iStopSpacing * Point;
            ObjectSet ("SHORT_STOP", OBJPROP_PRICE1, dShortStop);
         }   
      }   
      else
      {      
         if (Bid <= dShortEntry)
         {
            if (bFirstEntry == True)
            {
               iShortTicket = OrderSend (Symbol(), OP_SELL, Lots, Bid, slippage, 0, 0, NULL, 0, 0, Red);
               dLongEntry = dLastClose;
               ObjectSet ("LONG_ENTRY", OBJPROP_PRICE1, dLongEntry);
               dLongStop = dLongEntry - iStopSpacing * Point;
               ObjectSet ("LONG_STOP", OBJPROP_PRICE1, dLongStop);
               bFirstEntry = False;
               bInShort = True;
            }
            else
            {
               iShortTicket = OrderSend (Symbol(), OP_SELL, Lots, Bid, slippage, 0, 0, NULL, 0, 0, Red);
               bInShort = True;
            }
         }
      }
   }      
   return(0);
}


